flash_start	equ $C000
bank		equ $024D

	org $C080
	dw clear-1		; redirige commande CLEAR

	org $C1DB
	db 'F'			; remplace commande CLOAD par FLOAD
	org $C1E0
	db 'F'			; et CSAVE par FSAVE

	org $CCFF
	dw $0238                ; corrige l'oubli de redirection d'affichage

	org $E4AC
searchfile			; charge l'entte du programme demand (Z=0 si non trouv)
	jsr readrout_transfer
continue_search
	jsr readbyte
	bne return
	tax
	ldy #22		; 14 octets pour le nom, 8 pour l'entte
loadheader
	jsr readbyte
	sta $0293,x
	inx
	dey
	bne loadheader
	jsr compare_names
	beq return
	jsr nextfile
	jmp continue_search
readrout_transfer		; transfre la routine de lecture Flash en BFE0
	ldy #read_rout-write_rout
	db $2C
writerout_transfer		; transfre la routine d'criture Flash
	ldy #0
rout_transfer
	ldx #0
xfrloop lda write_rout,y
	sta $BFE0,x
	iny
	inx
	cpx #$20
	bne xfrloop
return
	rts
; full jusqu'en E4DF
; E4E0-E50A: charger un programme


; E50B-E56B: messages
	org $E527
not_found_msg
	string "File not found"
	db $0D,$0A,0

; E56C-E57C: passer octet suivant
; E57D-E5E9: affichage messages
; E5EA-E606: affichage et effacement ligne status

	org $E607
writeheader			; crit l'entte du programme au premier endroit libre
	jsr locatefree
	lda #0
	tax
writename
	jsr writebyte
	lda $027F,x
	inx
	cpx #15		; 0 initial + 14 octets de nom
	bne writename
	ldx #0
writehead
	lda $02A9,x
	jsr writebyte
	inx
	cpx #8		; en-tte [02A9-02B0]
	bne writehead
	rts
return_stack            ; pile de retour et de donnes pour la routine erase
                        ; (keskilfo pas faire pour economiser des octets)
        dw $BFEA-1
        db $80
        dw $BFF2-1
        db $30
        dw $BFE0-1
; full jusqu'en E62D

; E62E-E644 sauvegarde programme
; E645-E650 message sauvegarde

; E651-E65D test erreur
	org $E651
	rts			; pas d'erreur de lecture possible

getsector			; rcupre un numro de secteur de 1  7
	jsr $E853
	tya
	and #7
	beq sector_zero
	rts
sector_zero
	jmp $D336		; si 0 : ILLEGAL QUANTITY ERROR
; full jusqu'en E65D

	org $E65E
	jmp writebyte
write_rout			; routine d'criture Flash transfre en BFE0
	sta $C555
	lsr a
	sta $C2AA
	lda #$A0
	sta $C555
	jsr PB5pulse-write_rout+$BFE0
	lda $2F
write_inst
	sta flash_start
	lda #0
	sta $030F
PB5pulse
	sty $0300
	stx $0300
	rts

prepare_pulse
        lda $0300
	tax
        and #$DF
	tay
        lda bank
        sta $030F
return2
        rts

writeaddr equ write_inst+1-write_rout+$BFE0
writebyte			; criture d'un octet et passe au suivant
	sta $2F
	txa
	pha
	tya
	pha
        jsr prepare_pulse
	lda #$AA
	jsr $BFE0
	pla
	tay
	pla
	tax
	inc writeaddr
        bne return2
	inc writeaddr+1
        bne return2
	lda #$C0
	sta writeaddr+1
	lda bank
	clc
	adc #1
	and #$1F
	sta bank
        bne return2
	jmp $C47C	; plus de place: OUT OF MEMORY ERROR
get_bank		; rcupre un numro de secteur et calcule la banque correspondante
	jsr getsector
	asl a
	asl a
	sta bank
	rts
; full jusqu'en E6C8




	org $E6C9
	jmp readbyte
read_rout		; routine de lecture transfre en BFE0
	jsr bankselect-read_rout+$BFE0
read_inst
	lda flash_start-1
	pha
	lda #0
	jsr bankselect-read_rout+$BFE0
	pla
	rts
bankselect
	sta $030F
	lda $0300
	and #$DF
	sta $0300
	ora #$20
	sta $0300
	rts

readaddr equ read_inst+1-read_rout+$BFE0
readbyte		; lecture de l'octet suivant en Flash
	inc readaddr
	bne oktoread
	inc readaddr+1
	bne oktoread
        lda #0
        jsr testbank
oktoread
	lda bank
	jmp $BFE0
nextfile			; saute au fichier suivant
	lda readaddr
	sec
	sbc $02A1		; l'adresse de dpart trouve est en [02A1-02A2]
	tax
	lda readaddr+1
	sbc $02A2
	sta readaddr+1
	txa
	adc $02A3		; +1 grace au carry
	sta readaddr
	lda readaddr+1
	adc $02A4
testbank
	bcc nextfile_ok
	inc bank
	sbc #$40
	bcs testbank
nextfile_ok
	sta readaddr+1
	rts
prepare_stack
	lda return_stack,x
	pha
	dex
	bpl prepare_stack
	jmp prepare_pulse
; full jusqu'en E734



	org $E735
	rts		; pas besoin de synchro
erase_rout		; routine d'effacement de secteur transfre en BFE0
	lda flash_start
	bpl erase_rout
	lda #0
	sta $030F
	sty $0300
	stx $0300
	beq end_erase
	lda #$AA
	sta $C555
	lsr a
	sta $C2AA
	pla
	sta $C555
end_erase
	rts
clear	beq old_clear	; nouvelle commande CLEAR n : efface un secteur
	bne clear_sector
; full jusqu'en E759



	org $E75A
locatefree		; cherche si le fichier existe dj (MATCH ERROR)
			; sinon positionne au premier endroit libre
	jsr searchfile
	bne no_match
	jsr $E93D
	ldx #$B0
	jmp $C47E	; MATCH ERROR
old_clear	jmp $C70D	; saut  l'ancienne commande CLEAR
; full jusqu'en E769

	org $E76A
	sei		; inhibe les interruptions
	rts
clear_sector
	jsr get_bank
	php
	sei
	ldy #erase_rout-write_rout
	jsr rout_transfer
	ldx #7
	jsr prepare_stack
	plp
		; gagne 1 octet en laisse la routine s'couler sur la suivante (sans danger)
no_match
	lda readaddr+1
	pha
	lda readaddr
	pha
	jsr writerout_transfer
	pla
	sta writeaddr
	pla
	sta writeaddr+1
	rts
; full jusqu'en E78F

	org $E790
compare_names		; E790-E7AE comparaison nom demand / nom trouv
	lda $027F
	beq same_names
compare_loop
	lda $027F,y
	cmp $0293,y
	bne end_compare
	iny
	cmp #0
	bne compare_loop
same_names
	ldx #8
copy_header_loop
	lda $02A0,x
	sta $02A8,x
	dex
	bne copy_header_loop
end_compare
	rts
; 1 octet libre jusqu'en $E7AE
	

	org $E7B2
; syntaxe des commandes
	lda #4
	sta bank
	nop
	lda #0
	sta $02AD
	sta $02AE
	sta $025B
	sta $025A
	sta $025C
	sta $025D

	org $E7E3
	cpy #13		; limite les noms  13 caractres (plus 0 terminal)


	org $E822
; toujours dans la syntaxe
	cmp #$41
	beq getblockparam
	cmp #$45
	beq getblockparam
	cmp #$53		; option S<secteur>
	bne $E871
	jsr $00E2
	jsr get_bank
	bne $E7EC
getblockparam
	lsr a
	sta $0E
	jsr $00E2
	ldx #$80
	stx $02AE
	jsr $E853
	ldx $0E
	sta $028A,x
	tya
	sta $0289,x
	jmp $E7EC
; 2 octets libres jusqu'en E851


; E85B-E908 commande CLOAD
	org $E877
	jsr searchfile
	bne file_not_found
	nop
	bit $02AE
	bvs file_not_found

	org $e88a
	bne file_not_found	



	org $E8D3
; toujours dans la commande CLOAD
	lda $02AE
	beq basic
	lda $02AD
	beq endload
	jmp ($02A9)
endload	rts
basic	ldx $02AB
	lda $02AC
	stx $9C
	sta $9D
	jsr $C55F
	jsr $C708
	lda $02AD
	bne endload
	jmp $C4A8
file_not_found
	plp
	lda #LOW(not_found_msg)
	ldy #HIGH(not_found_msg)
	jmp $CCB0
; place libre jusqu'en E908
; E909-E93C commande CSAVE
; E93D-E945 reconfigurer le VIA


	end
